# NG-MENTIONS

[![Browser Tests And Coverage](https://github.com/nth-cloud/ng-mentions/actions/workflows/browser-tests.yml/badge.svg)](https://github.com/nth-cloud/ng-mentions/actions/workflows/browser-tests.yml)
[![npm version](https://badge.fury.io/js/%40nth-cloud%2Fng-mentions.svg)](https://badge.fury.io/js/%40nth-cloud%2Fng-mentions)
[![codecov](https://codecov.io/gh/nth-cloud/ng-mentions/branch/master/graph/badge.svg)](https://codecov.io/gh/nth-cloud/ng-mentions)

Native Angular components & directives for customizable mentions. Allowing for customizable search results and mention formatting.

## Demo and Docs

View it in action at https://nth-cloud.github.io/ng-mentions

## Dependencies
* [Angular](https://angular.io) (tested with 15.1.5)

| ng-mentions | Angular |   Active Support   |
|-------------|---------|:------------------:|
| 5.x.x       | 10.0.0  |        :x:         |
| 6.x.x       | 11.0.0  |        :x:         |
| 7.x.x       | 12.0.0  |        :x:         |
| 8.x.x       | 13.0.0  | :white_check_mark: |
| 9.x.x       | 14.0.0  | :white_check_mark: |
| 10.x.x      | 15.0.0  | :white_check_mark: |

## Installation

We strongly recommend using [Angular CLI](https://cli.angular.io) for setting up a new project. If you have an Angular &ge; 9 CLI project, you could simply use our schematics to add ng-mentions library to it.

Just run the following:

```shell
ng add @nth-cloud/ng-mentions
```

It will install ng-mentions for the default application specified in your `angular.json`.
If you have multiple projects and you want to target a specific application, you could specify the `--project` option:

```shell
ng add @nth-cloud/ng-mentions --project myProject
```

If you prefer not to use schematics and install everything manually, please refer to the
[manual installation instructions](https://nth-cloud.github.io/ng-mentions/#/home) on our website.

## Supported browsers
We strive to support the same browsers and versions as supported by Angular.
See [Angular Browser Support](https://github.com/angular/angular/blob/master/README.md) for more details.

